<?php
if (!defined('PmWiki')) exit();
/*  
    Copyright (2003) Ross Kowaski
    Modified 12-Jul-2003 by Patrick R. Michaud
    Adapted for Wiki 2.0 by Robert Novotny    

    This script provides two options for automatically 
    generating a list of the groups avilable in a pmwiki.
    To use the script, place it in your local directory,
    include the script by adding the following line to your local.php

    include_once("cookbook/grouplist.php"); in local.php

    then add (:grouplist fmt=h:) or (:grouplist fmt=v:) (or other format 
    specified by character following the ,,fmt=") to your wiki page.
    The h and v specifying the format are for horizontal and vertical 
    formatting of the resulting list.
    
    Other formats are defined below.

    Updated 13-Jul-2003 by pmichaud
      - Changed output to be XHTML-compliant
      - Made output configurable
      - Only uses files in wiki.d which are valid pagenames
      - works with E_NOTICE set

*/

define(GROUPLIST_VERSION, '1.0');

//place markup after ,,conversion of links" phase, otherwise will
//be $Group expanded to URL, thus breaking <a..> links
Markup("grouplist","block","/\\(:grouplist fmt=([vhl]):\\)/e", "FmtGrouplist($1)");

/*
  Define various styles. 
  If you want to define additional styles, remember to update regular
  expression above
*/
SDV($GroupListFmt['v'],
  "<a href='$ScriptUrl/\$Group/\$DefaultName'><font size='2'>\$Group</font></a><br />");
SDV($GroupListFmt['h'],
  "<a href='$ScriptUrl/\$Group/\$DefaultName'>\$Group</a> &nbsp; &nbsp;");   
SDV($GroupListFmt['l'],
  "<ul><li><a href='$ScriptUrl/\$Group/\$DefaultName'>\$Group</a></li></ul>");   

function FmtGrouplist($type = 'l') 
{ 
  global $WikiDir, $GroupPattern, $NamePattern, $GroupListFmt; 

    //get object for browsing page names
    $pages = $WikiDir->ls();  

    $grouplist = array();
    //iterate $WikiDir items
    foreach($pages as $p) {  
	if (preg_match("/^($GroupPattern)\.($NamePattern)\$/", $p, $match)) {
	    //extract GroupName for each page, use it as a key of the array
	    //thus solving duplicate groups
    	    $grouplist[$match[1]]++;    
        }
    }
  
    //sort groups
    ksort($grouplist);
    reset($grouplist);
    
    //iterate and put items into array;
    $out = array();
    foreach($grouplist as $g=>$v) {
	$out[] = FmtPageName($GroupListFmt[$type], "$g.HomePage");
    }
    return implode("\n",$out);
}

?>
